import { loginStatusPage, post } from '@/utils/https';
import { SaleOrderProcessStateOption } from '@/utils/config';
import {
  cloneLite,
  getAuthInfo,
  getDataSet,
  searchValueFormat,
  toArray,
  toNumber,
} from '@/utils/util';

const defaultParams = { curr_page: 1, page_count: 20, process_state: [200] };

Page({
  /**
   * 页面的初始数据
   */
  data: {
    params: cloneLite(defaultParams) as any,
    list: [] as any[],
    count: 0,
    saleOrderProcessStateOption: SaleOrderProcessStateOption,
    sort: [{ label: '创建日期', value: 'create_date' }],
    detail: { show: false, title: '', data: [] as any[] },
  },
  handleLogin(e: any) {
    this.setData({ isLogin: e.detail });
    if (e.detail) {
      this.init();
    }
  },
  init() {
    this.setData({ authInfo: getAuthInfo() });
    this.getList();
  },
  searchChange(e: any) {
    const key = getDataSet(e).key;
    const val = searchValueFormat(e.detail.value);
    if (val) {
      this.data.params[key] = val;
    } else {
      delete this.data.params[key];
    }
    this.setData({ params: this.data.params });
  },
  searchOk() {
    this.getList(1);
  },
  searchReset() {
    this.data.params = cloneLite(defaultParams);
    this.getList(1);
  },
  onSort(e: any) {
    this.data.params.order = e.detail.value;
    this.setData({ params: this.data.params });
    this.getList(1);
  },
  paginationChange(e: any) {
    this.getList(e.detail.curr_page);
  },
  getList(curr: number = 1) {
    this.data.params.curr_page = curr;
    this.setData({ params: this.data.params });
    const temp = cloneLite(this.data.params);
    if (temp.process_state && temp.process_state.length) {
      temp.process_state = temp.process_state.join(',');
    } else {
      delete temp.process_state;
    }

    post('ProduceOrder/getListV2', temp).then((res: any) => {
      const list = toArray(res.data);
      if (list.length == 0 && this.data.params.curr_page > 1) {
        this.getList(this.data.params.curr_page - 1);
      }
      this.setData({ count: toNumber(res.count), list });
    });
  },

  onDetail(e: any) {
    const data = getDataSet(e);
    const index = data.index;
    const index2 = data.index2;
    const item = this.data.list[index];
    const item2 = item?.produce_info[index2] || {};
    // console.log(index, index2, item);
    const produce_info_process = toArray(item2.produce_info_process);
    if (produce_info_process.length == 0) {
      return;
    }
    this.setData({
      detail: {
        show: true,
        title: `${item2.goods_name} 流程配置`,
        data: toArray(item2.produce_info_process),
      },
    });
  },
  onClose() {
    this.data.detail.show = false;
    this.setData({ detail: this.data.detail });
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad(_options) {},

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady() {},

  /**
   * 生命周期函数--监听页面显示
   */
  onShow() {
    loginStatusPage(this);
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide() {},

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload() {},

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() {},

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom() {},

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage() {},
});
